#ifndef _COMMON_SAND_H
#define _COMMON_SAND_H

#include <list>
#include <unistd.h>

#define PACKED __attribute__((__packed__))
#define COUNTOF(obj, type) (sizeof(obj) / sizeof(type))

/* DIRTSAND types */
typedef bool dsBool;
typedef unsigned short dsChar;
typedef unsigned char dsUByte;
typedef signed char dsByte;
typedef unsigned short dsUInt16;
typedef signed short dsInt16;
typedef unsigned int dsUInt32;
typedef signed int dsInt32;
typedef unsigned long long dsUInt64;
typedef signed long long dsInt64;
typedef float dsFloat;
typedef double dsDouble;

/* Transaction status */
enum ENetError {
    kNetPending = -1,
    kNetSuccess = 0, kNetErrInternalError, kNetErrTimeout, kNetErrBadServerData,
    kNetErrAgeNotFound, kNetErrConnectFailed, kNetErrDisconnected,
    kNetErrFileNotFound, kNetErrOldBuildId, kNetErrRemoteShutdown,
    kNetErrTimeoutOdbc, kNetErrAccountAlreadyExists, kNetErrPlayerAlreadyExists,
    kNetErrAccountNotFound, kNetErrPlayerNotFound, kNetErrInvalidParameter,
    kNetErrNameLookupFailed, kNetErrLoggedInElsewhere, kNetErrVaultNodeNotFound,
    kNetErrMaxPlayersOnAcct, kNetErrAuthenticationFailed,
    kNetErrStateObjectNotFound, kNetErrLoginDenied, kNetErrCircularReference,
    kNetErrAccountNotActivated, kNetErrKeyAlreadyUsed, kNetErrKeyNotFound,
    kNetErrActivationCodeNotFound, kNetErrPlayerNameInvalid,
    kNetErrNotSupported, kNetErrServiceForbidden, kNetErrAuthTokenTooOld,
    kNetErrMustUseGameTapClient, kNetErrTooManyFailedLogins,
    kNetErrGameTapConnectionFailed, kNetErrGTTooManyAuthOptions,
    kNetErrGTMissingParameter, kNetErrGTServerError, kNetErrAccountBanned,
    kNetErrKickedByCCR, kNumNetErrors,
};

/* Protocol Types */
enum ENetProtocol {
    kNetProtocolNil, kNetProtocolDebug, kNetProtocolCli2AdminShell,
    kNetProtocolUnused_00, kNetProtocolCli2Auth, kNetProtocolCli2Game,
    kNetProtocolCli2File,

    kNetProtocolSrvConn = 0x80, kNetProtocolSrv2Mcp, kNetProtocolSrv2Vault,
    kNetProtocolSrv2Db, kNetProtocolSrv2State, kNetProtocolSrv2Log,
};

// List of the process children we're keeping track of
extern std::list<pid_t> s_children;

#endif
