#include "CommonSand.h"
#include "dsUuid.h"

/* Connection Types */
enum EConnType {
    kConnTypeNil, kConnTypeDebug,
    kConnTypeCliToAuth = 10, kConnTypeCliToGame,
    kConnTypeCliToFile = 16,

    kConnType_BeginDS = 160,
    kConnTypeVault_DS, kConnTypeAdmin_DS,
};

/* Connection header for all servers */
struct PACKED ConnectHeader {
    dsUByte fConnType;
    dsUInt16 fSockHeaderSize;
    dsUInt32 fBuildId, fBuildType, fBranchId;
    dsUuid fProductId;
};

/* Encryption setup messages */
enum NetCliConnectMsg {
    kNetCliCli2SrvConnect, kNetCliSrv2CliEncrypt, kNetCliSrv2CliError,
    kNumNetCliMsgs
};

#define NetCli_Header \
    dsUByte fMessage, fLength;

struct PACKED NetCli_Cli2Srv_Connect {
    NetCli_Header
    dsUByte fKeyYData[64];
};

struct PACKED NetCli_Srv2Cli_Encrypt {
    NetCli_Header
    dsUByte fSeed[7];
};

struct PACKED NetCli_Srv2Cli_Error {
    NetCli_Header
    dsUInt32 fError;
};
