#include "dsStateDescriptor.h"

/* dsVarDescriptor */
dsInt32 dsVarDescriptor::typeFromName(const dsString& typeStr)
{
    if (typeStr[0] == (dsChar)'$')
        return kStateDesc;
    else if (typeStr == "INT")
        return kInt;
    else if (typeStr == "FLOAT")
        return kFloat;
    else if (typeStr == "BOOL")
        return kBool;
    else if (typeStr == "STRING32")
        return kString;
    else if (typeStr == "PLKEY")
        return kKey;
    else if (typeStr == "CREATABLE" || typeStr == "MESSAGE")
        return kCreatable;
    else if (typeStr == "DOUBLE")
        return kDouble;
    else if (typeStr == "TIME")
        return kTime;
    else if (typeStr == "BYTE")
        return kByte;
    else if (typeStr == "SHORT")
        return kShort;
    else if (typeStr == "AGETIMEOFDAY")
        return kAgeTimeOfDay;
    else if (typeStr == "VECTOR3")
        return kVector3;
    else if (typeStr == "POINT3")
        return kPoint3;
    else if (typeStr == "RGB")
        return kRGB;
    else if (typeStr == "RGBA")
        return kRGBA;
    else if (typeStr == "QUAT" || typeStr == "QUATERNION")
        return kQuat;
    else if (typeStr == "RGB8")
        return kRGB8;
    else if (typeStr == "RGBA8")
        return kRGBA8;
    else
        return kNone;
}

/* dsStateDescriptor */
void dsStateDescriptor::addVariable(const dsVarDescriptor& var)
{
    fData->fVariables.push_back(var);
}

dsVarDescriptor dsStateDescriptor::operator[](const dsString& name) const
{
    std::list<dsVarDescriptor>::iterator i;
    for (i = fData->fVariables.begin(); i != fData->fVariables.end(); i++) {
        if (i->name() == name)
            return *i;
    }
    return dsVarDescriptor(NULL);
}

std::vector<dsVarDescriptor> dsStateDescriptor::variables() const
{
    return std::vector<dsVarDescriptor>(fData->fVariables.begin(),
                                        fData->fVariables.end());
}
