#ifndef _DS_AUTH_DATA_H
#define _DS_AUTH_DATA_H

#include "../dsString.h"

struct dsAuthFileInfo {
    dsString fFilename;
    dsUInt32 fFileSize;

    inline size_t calcSize() const;
    ssize_t writeData(dsChar* buf, size_t maxlen) const;
};

class dsAuthFileList {
protected:
    std::vector<dsAuthFileInfo> fFiles;
    ENetError fStatus;

public:
    inline dsAuthFileList();

    void read(const dsString& directory, const dsString& ext);
    void write(dsChar* buf, size_t maxlen);

    inline ENetError getStatus() const;
    inline size_t getNumFiles() const;
    inline const dsAuthFileInfo& getFile(size_t idx) const;
    size_t calcTotalSize() const;
};

class dsAuthFileData {
protected:
    size_t fFileSize, fFilePos;
    dsUByte* fFileData;
    ENetError fStatus;

public:
    inline dsAuthFileData();
    inline ~dsAuthFileData();

    void read(const dsString& filename);
    void write(dsUByte* buf, size_t maxlen);

    inline ENetError getStatus() const;
    inline size_t getTotalSize() const;
    inline dsUInt32 getPos() const;
    inline void setFinished();
};

#include "dsAuthData.inl"

#endif
