/* dsAuthFileInfo */
size_t dsAuthFileInfo::calcSize() const
{
    // Filename, Z-Term, UInt32, Z-Term
    return fFilename.length() + 4;
}


/* dsAuthFileList */
dsAuthFileList::dsAuthFileList()
              : fStatus(kNetPending)
{ }

ENetError dsAuthFileList::getStatus() const
{
    return fStatus;
}

size_t dsAuthFileList::getNumFiles() const
{
    return fFiles.size();
}

const dsAuthFileInfo& dsAuthFileList::getFile(size_t idx) const
{
    return fFiles[idx];
}


/* dsAuthFileData */
dsAuthFileData::dsAuthFileData()
              : fFileSize(0), fFilePos(0), fFileData(NULL), fStatus(kNetPending)
{ }

dsAuthFileData::~dsAuthFileData()
{
    if (fFileData != NULL)
        delete[] fFileData;
}

ENetError dsAuthFileData::getStatus() const
{
    return fStatus;
}

size_t dsAuthFileData::getTotalSize() const
{
    return fFileSize;
}

size_t dsAuthFileData::getPos() const
{
    return fFilePos;
}

void dsAuthFileData::setFinished()
{
    fFilePos = fFileSize;
}
