dsAuthServer::dsAuthServer(dsSocket* sock)
            : fSock(sock), fVault(dsVaultClient::getConnection(), this)
{
    fLoginInfo.fResult = kNetPending;
    fPlayerInfo.fResult = kNetPending;
    if (fVault.getStatus() != kNetErrConnectFailed)
        fVault.start();
}

dsAuthServer::~dsAuthServer()
{
    fVault.signalFinish();
}

dsUInt32 dsAuthServer::waitForNode(dsUInt32 transId, dsInt32& nodeId)
{
    std::map<dsUInt32, dsInt32>::iterator f;
    fVaultTransMutex.lock();
    while ((f = fCreateQueue.find(transId)) == fCreateQueue.end()) {
        fVaultTransMutex.unlock();
        dsThread::Yield();
        fVaultTransMutex.lock();
    }
    nodeId = f->second;
    fCreateQueue.erase(f);
    std::map<dsUInt32, dsUInt32>::iterator status = fStatusQueue.find(transId);
    dsUInt32 result = status->second;
    fStatusQueue.erase(status);
    fVaultTransMutex.unlock();
    return result;
}

dsUInt32 dsAuthServer::waitForNodeList(dsUInt32 transId, std::vector<dsInt32>& nodeList)
{
    std::map<dsUInt32, std::vector<dsInt32> >::iterator f;
    fVaultTransMutex.lock();
    while ((f = fFindQueue.find(transId)) == fFindQueue.end()) {
        fVaultTransMutex.unlock();
        dsThread::Yield();
        fVaultTransMutex.lock();
    }
    nodeList = f->second;
    fFindQueue.erase(f);
    std::map<dsUInt32, dsUInt32>::iterator status = fStatusQueue.find(transId);
    dsUInt32 result = status->second;
    fStatusQueue.erase(status);
    fVaultTransMutex.unlock();
    return result;
}

dsUInt32 dsAuthServer::waitForStatus(dsUInt32 transId)
{
    std::map<dsUInt32, dsUInt32>::iterator f;
    fVaultTransMutex.lock();
    while ((f = fStatusQueue.find(transId)) == fStatusQueue.end()) {
        fVaultTransMutex.unlock();
        dsThread::Yield();
        fVaultTransMutex.lock();
    }
    dsUInt32 result = f->second;
    fStatusQueue.erase(f);
    fVaultTransMutex.unlock();
    return result;
}
