#ifndef _DS_RC4_H
#define _DS_RC4_H

#include "../dsString.h"
#include "../dsSocket.h"
#include "../dsNetMsg.h"
#include <cstdlib>

enum ECryptAlgorithm {
    kCryptSha, kCryptSha1, kCryptMd5, kCryptRc4, kCryptRsa,
    kNumCryptAlgorithms
};

class dsRC4Socket : public dsAsyncSocket {
protected:
    struct _crypt {
        dsUByte fState[256];
        size_t fX, fY;
        dsMutex fLock;
        void crypt(size_t size, const dsUByte* src, dsUByte* dest);
    } fSend, fRecv;
    bool fEncrypted;

public:
    inline dsRC4Socket(dsSocket* sock);
    void init(size_t keySize, dsUByte* keyData);

    ssize_t send(const void* buf, size_t size);
    ssize_t recv(void* buf, size_t size);
    ssize_t peek(void* buf, size_t size);

    dsString recvString(size_t maxlen);
    bool sendMsg(const msgparm_t* data, const dsNetMsg* msg);
    msgparm_t* recvMsg(const dsNetMsg* msg);

    static void test();

protected:
    inline void lockSend();
    inline void lockRecv();
    inline void unlockSend();
    inline void unlockRecv();
};

#include "dsRC4.inl"

#endif
