#ifndef _DS_CONFIG_MGR_H
#define _DS_CONFIG_MGR_H

#include "dsString.h"
#include "dsThread.h"
#include <map>

class dsConfigMgr {
private:
    static std::map<dsString, dsString> fConfig;
    static dsString fBaseDir;
    static dsMutex fConfigMutex;

public:
    static bool LoadConfig(const char* filename);

    static dsString GetString(const dsString& name, const dsString& def = "");
    static dsString GetPath(const dsString& name, const dsString& filename = "");
    static dsUInt32 GetUInt(const dsString& name, dsUInt32 def = 0);
    static dsInt32 GetInt(const dsString& name, dsInt32 def = 0);
};

// Defaults for various dsConfigMgr settings
#define LISTENPORT_DEFAULT 14617
#define DBHOST_DEFAULT "localhost"
#define DBPORT_DEFAULT "5432"
#define DBUSER_DEFAULT "dirtsand"
#define DBPASS_DEFAULT "dirtsand"
#define DBSSLMODE_DEFAULT "prefer"
#define DBNAME_DEFAULT "dirtsand"
#define LOGLEVEL_DEFAULT 3
#define NULL_TOKEN_STR "00000000-0000-0000-0000-000000000000"
#define VAULTHOST_DEFAULT "localhost"
#define GAMEHOST_DEFAULT "localhost"

#endif
