#ifndef _DS_LOG_H
#define _DS_LOG_H

#include <cstdio>
#include <cstdarg>
#include <map>
#include "CommonSand.h"
#include "dsThread.h"

typedef enum {
    kLogError, kLogWarning, kLogInfo, kLogDebug
} ELogType;

class dsLogProcessor {
private:
    FILE* fFileDesc;
    ELogType fMaxLevel;
    char* fAddrName;
    dsMutex fLogMutex;

    static const char* kLogTypeNames[];
    static dsLogProcessor* fCurrentLogger;

public:
    ~dsLogProcessor();
    static dsLogProcessor* Create(const char* basename, ELogType maxLevel);
    inline static void Destroy();
    inline static void setLog(dsLogProcessor* log, bool deleteOld = false);
    inline static dsLogProcessor* getLog();

    inline int getFD() const;
    void setAddress(const char* addr);
    void write(ELogType type, const char* msg);
};

inline void dsLog(ELogType type, const char* fmt);
inline void dsLogF(ELogType type, const char* fmt, ...);
inline void dsLogV(ELogType type, const char* fmt, va_list args);
inline void dsLogFD();

#include "dsLog.inl"

#endif
