#include <cstdlib>

void dsLogProcessor::Destroy()
{
    if (fCurrentLogger != NULL)
        delete fCurrentLogger;
}

void dsLogProcessor::setLog(dsLogProcessor* log, bool deleteOld)
{
    if (deleteOld && fCurrentLogger != NULL)
        delete fCurrentLogger;
    fCurrentLogger = log;
    atexit(&dsLogProcessor::Destroy);
}

dsLogProcessor* dsLogProcessor::getLog()
{
    return fCurrentLogger;
}

int dsLogProcessor::getFD() const
{
    return fileno(fFileDesc);
}

void dsLog(ELogType type, const char* fmt)
{
    dsLogProcessor::getLog()->write(type, fmt);
}

void dsLogF(ELogType type, const char* fmt, ...)
{
    va_list argptr;
    va_start(argptr, fmt);
    dsLogV(type, fmt, argptr);
    va_end(argptr);
}

void dsLogV(ELogType type, const char* fmt, va_list args)
{
    char* buf;
    if (vasprintf(&buf, fmt, args) >= 0) {
        dsLogProcessor::getLog()->write(type, buf);
        free(buf);
    } else {
        dsLogProcessor::getLog()->write(kLogError, "(Fatal error in dsLogV)");
    }
}
