#include "CommonSand.h"

#ifndef _DS_NETMSG_H
#define _DS_NETMSG_H

enum ENetMsgFieldType {
    kFieldInteger, kFieldFloat, kFieldString, kFieldData, kFieldPtr,
    kFieldVarPtr, kFieldRawData, kFieldRawPtr, kFieldRawVarPtr, kFieldVarCount
};

struct PACKED dsNetMsgField {
    ENetMsgFieldType fType;
    dsUInt32 fCount, fSize;
};

struct PACKED dsNetMsg {
    dsUInt32 fMsgId;
    const char* const fMsgName;
    dsUInt32 fFieldCount;
    dsNetMsgField* fFields;
};

typedef dsUInt64 msgparm_t;
msgparm_t* AllocMessage(const dsNetMsg* msg);
void FreeMessage(msgparm_t* data, const dsNetMsg* msg);
size_t MessageSize(const msgparm_t* data, const dsNetMsg* msg);

#define MAKE_NETMSG(name) \
    static dsNetMsg name = { \
        k##name, #name, \
        COUNTOF(name##_Fields, dsNetMsgField), \
        name##_Fields \
    };

#endif
