/* dsSocket */
dsSocket::dsSocket()
        : fSockHandle(-1)
{ }

dsSocket::dsSocket(int handle)
        : fSockHandle(handle)
{ }

dsSocket::~dsSocket()
{
    close();
}

int dsSocket::getHandle() const
{
    return fSockHandle;
}

void dsSocket::unlink()
{
    fSockHandle = -1;
    delete this;
}

void dsSocket::link(int handle)
{
    fSockHandle = handle;
}


#include "dsLog.h"
/* dsAsyncSocket */
dsAsyncSocket::_async::_async()
             : fSock(NULL), fReadPos(0)
{ }

void dsAsyncSocket::_async::initialize()
{ }

void dsAsyncSocket::_async::finalize()
{
    flush();
}

void dsAsyncSocket::_async::flush()
{
    while (!fSendQueue.empty() || !fRecvQueue.empty())
        /* wait for the I/O queues to flush */
        dsThread::Yield();
}

dsAsyncSocket::dsAsyncSocket(dsSocket* sock)
{
    fAsyncIO.fSock = sock;
    fAsyncIO.start();
}

dsAsyncSocket::~dsAsyncSocket()
{
    fAsyncIO.signalFinish();
}

void dsAsyncSocket::flush()
{
    fAsyncIO.flush();
}

bool dsAsyncSocket::readAvailable() const
{
    return (!fAsyncIO.fRecvQueue.empty());
}

bool dsAsyncSocket::waitForData()
{
    while (isConnected() && !readAvailable())
        dsThread::Yield();
    return isConnected();
}

bool dsAsyncSocket::isConnected() const
{
    return !fAsyncIO.isFinished();
}

void dsAsyncSocket::close(bool force)
{
    fAsyncIO.fSock->close(force);
}
