#ifndef _DS_THREAD_H
#define _DS_THREAD_H

#include <pthread.h>

class dsThread {
protected:
    pthread_t fThreadHandle;
    bool fFinished;

public:
    inline dsThread();
    inline virtual ~dsThread();

    inline void start();
    inline void dbgStart();
    inline void wait();
    inline void signalFinish();
    inline bool isFinished() const;

    inline static void Exit();
    inline static void Yield();

protected:
    inline static void* s_threadstart(void* self);
    inline virtual void initialize();
    virtual void run() = 0;
    inline virtual void finalize();
};

class dsMutex {
protected:
    pthread_mutex_t fMutex;

public:
    inline dsMutex();
    inline ~dsMutex();

    inline void lock();
    inline void unlock();
};

#include "dsThread.inl"

#endif
