/* dsThread */
dsThread::dsThread()
        : fThreadHandle((pthread_t)-1), fFinished(false)
{ }

dsThread::~dsThread()
{
    if ((int)fThreadHandle > 0 && !fFinished)
        pthread_cancel(fThreadHandle);
}

void dsThread::start()
{
    if (pthread_create(&fThreadHandle, NULL, &dsThread::s_threadstart, this) != 0)
        fFinished = true;
}

void dsThread::dbgStart()
{
    s_threadstart(this);
}

void dsThread::wait()
{
    while (!fFinished)
        Yield();
}

void dsThread::signalFinish()
{
    fFinished = true;
}

bool dsThread::isFinished() const
{
    return fFinished;
}

void* dsThread::s_threadstart(void* self)
{
    ((dsThread*)self)->initialize();
    if (!((dsThread*)self)->fFinished)
        ((dsThread*)self)->run();
    ((dsThread*)self)->fFinished = true;
    ((dsThread*)self)->finalize();
    return NULL;
}

void dsThread::initialize()
{ }

void dsThread::finalize()
{ }

void dsThread::Exit()
{
    pthread_exit(NULL);
}

void dsThread::Yield()
{
    pthread_yield();
}


/* dsMutex */
dsMutex::dsMutex()
{
    pthread_mutex_init(&fMutex, NULL);
}

dsMutex::~dsMutex()
{
    pthread_mutex_destroy(&fMutex);
}

void dsMutex::lock()
{
    pthread_mutex_lock(&fMutex);
}

void dsMutex::unlock()
{
    pthread_mutex_unlock(&fMutex);
}
