#include "dsUuid.h"

dsUuid dsUuid::fromString(const dsString& str)
{
    if (str.length() != 36 || str[ 8] != '-' || str[13] != '-'
                           || str[18] != '-' || str[23] != '-')
        /* Invalid format */
        return dsUuid();

    dsUuid uuid;
    uuid.fData1 = str.mid(0, 8).toUInt(16);
    uuid.fData2 = str.mid(9, 4).toUInt(16);
    uuid.fData3 = str.mid(14, 4).toUInt(16);
    uuid.fData4[0] = str.mid(19, 2).toUInt(16);
    uuid.fData4[1] = str.mid(21, 2).toUInt(16);
    uuid.fData4[2] = str.mid(24, 2).toUInt(16);
    uuid.fData4[3] = str.mid(25, 2).toUInt(16);
    uuid.fData4[4] = str.mid(28, 2).toUInt(16);
    uuid.fData4[5] = str.mid(30, 2).toUInt(16);
    uuid.fData4[6] = str.mid(32, 2).toUInt(16);
    uuid.fData4[7] = str.mid(34, 2).toUInt(16);
    return uuid;
}

dsString dsUuid::asString() const
{
    return dsString::Format("%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x",
                            fData1, fData2, fData3, fData4[0], fData4[1],
                            fData4[2], fData4[3], fData4[4], fData4[5],
                            fData4[6], fData4[7]);
}
