#ifndef _DS_UUID_H
#define _DS_UUID_H

#include "CommonSand.h"
#include "dsString.h"

struct PACKED dsUuid {
    union {
        dsUByte fData[16];
        struct PACKED {
            dsUInt32 fData1;
            dsUInt16 fData2, fData3;
            dsUByte fData4[8];
        };
    };

    inline dsUuid();
    inline dsUuid(const dsUByte* data);
    inline dsUuid(const dsUuid& init);
    static dsUuid fromString(const dsString& str);
    dsString asString() const;

    inline dsUuid& operator=(const dsUuid& other);
    inline bool operator==(const dsUuid& other) const;
    inline bool operator!=(const dsUuid& other) const;
};

#include "dsUuid.inl"

#endif
