#include "../CommonSand.h"

enum {
    /* Client -> Server */
    kCli2File_PingRequest = 0,
    kCli2File_BuildIdRequest = 10,
    kCli2File_ManifestRequest = 20,
    kCli2File_FileDownloadRequest = 21,
    kCli2File_ManifestEntryAck = 22,
    kCli2File_FileDownloadChunkAck = 23,

    /* Server -> Client */
    kFile2Cli_PingReply = 0,
    kFile2Cli_BuildIdReply = 10,
    kFile2Cli_BuildIdUpdate = 11,
    kFile2Cli_ManifestReply = 20,
    kFile2Cli_FileDownloadReply = 21,
};

struct PACKED FileMsg_Header {
    dsUInt32 fMsgSize;
    dsUInt32 fMsgId;
};

struct PACKED Cli2File_PingRequest {
    dsUInt32 fPingTimeMs;
};

struct PACKED Cli2File_BuildIdRequest {
    dsUInt32 fTransId;
};

struct PACKED Cli2File_ManifestRequest {
    dsUInt32 fTransId;
    dsChar   fGroup[260];
    dsUInt32 fBuildId;
};

struct PACKED Cli2File_FileDownloadRequest {
    dsUInt32 fTransId;
    dsChar   fFilename[260];
    dsUInt32 fBuildId;
};

struct PACKED Cli2File_ManifestEntryAck {
    dsUInt32 fTransId;
    dsUInt32 fReaderId;
};

struct PACKED Cli2File_FileDownloadChunkAck {
    dsUInt32 fTransId;
    dsUInt32 fReaderId;
};

struct PACKED File2Cli_PingReply {
    dsUInt32 fPingTimeMs;
};

struct PACKED File2Cli_BuildIdReply {
    dsUInt32 fTransId;
    dsUInt32 fResult;
    dsUInt32 fBuildId;
};

struct PACKED File2Cli_BuildIdUpdate {
    dsUInt32 fBuildId;
};

struct PACKED File2Cli_ManifestReply {
    dsUInt32 fTransId;
    dsUInt32 fResult;
    dsUInt32 fReaderId;
    dsUInt32 fNumFiles;
    dsUInt32 fDataSize;
};

struct PACKED File2Cli_FileDownloadReply {
    dsUInt32 fTransId;
    dsUInt32 fResult;
    dsUInt32 fReaderId;
    dsUInt32 fFileSize;
    dsUInt32 fDataSize;
};
