#include "dsFileData.h"
#include "../dsLog.h"
#include "../dsConfigMgr.h"

void dsFileData::read(const dsString& filename)
{
    dsString path = dsConfigMgr::GetPath("DataDir", filename);
    FILE* src = fopen(path.cstr(), "rb");
    if (src == NULL) {
        dsLogF(kLogWarning, "Could not open file %s", filename.cstr().data());
        fStatus = kNetErrInternalError;
        return;
    }
    fseek(src, 0, SEEK_END);
    fFileSize = ftell(src);
    fseek(src, 0, SEEK_SET);
    if (fFileData != NULL)
        delete[] fFileData;
    if (fFileSize > 0) {
        fFileData = new dsUByte[fFileSize];
        fread(fFileData, sizeof(dsUByte), fFileSize, src);
    } else {
        fFileData = NULL;
    }
    fclose(src);
    fStatus = kNetSuccess;
}

void dsFileData::write(dsUByte* buf, size_t len)
{
    if (len + fFilePos > fFileSize) {
        dsLog(kLogWarning, "Requested more data than available");
        len = (fFileSize - fFilePos);
    }
    memcpy(buf, fFileData + fFilePos, len);
    fFilePos += len;
    fStatus = kNetSuccess;
}
