#ifndef _DS_MANIFEST_H
#define _DS_MANIFEST_H

#include "../dsString.h"

struct dsMfsEntry {
    dsString fFilename, fDownloadName;
    dsString fHash, fCompressedHash;
    dsUInt32 fFileSize, fCompressedSize, fFlags;

    inline size_t calcSize() const;
    ssize_t writeData(dsChar* buf, size_t maxlen) const;
};

class dsManifest {
protected:
    std::vector<dsMfsEntry> fFiles;
    ENetError fStatus;

public:
    inline dsManifest();

    void read(const dsString& filename);
    void write(dsChar* buf, size_t maxlen);

    inline ENetError getStatus() const;
    inline size_t getNumFiles() const;
    inline const dsMfsEntry& getFile(size_t idx) const;
    size_t calcTotalSize() const;
};

#include "dsManifest.inl"

#endif
