#include "GameMessages.h"

/* Client -> Server */
static dsNetMsgField Cli2Game_PingRequest_Fields[] = {
    { kFieldInteger,    0, sizeof(dsUInt32) },  // Ping time
};
MAKE_NETMSG(Cli2Game_PingRequest)

static dsNetMsgField Cli2Game_JoinAgeRequest_Fields[] = {
    { kFieldInteger,    0, sizeof(dsUInt32) },  // Trans ID
    { kFieldInteger,    0, sizeof(dsUInt32) },  // Age MCP ID
    { kFieldData,      16, sizeof(dsUByte)  },  // Account Uuid
    { kFieldInteger,    0, sizeof(dsUInt32) },  // Player ID
};
MAKE_NETMSG(Cli2Game_JoinAgeRequest)

static dsNetMsgField Cli2Game_PropagateBuffer_Fields[] = {
    { kFieldInteger,    0, sizeof(dsUInt32) },  // Message Type
    { kFieldVarCount,   0, sizeof(dsUByte)  },  // Buffer Data
    { kFieldVarPtr,     0, 0                },
};
MAKE_NETMSG(Cli2Game_PropagateBuffer)

static dsNetMsgField Cli2Game_GameMgrMsg_Fields[] = {
    { kFieldVarCount,   0, sizeof(dsUByte)  },  // Message Data
    { kFieldVarPtr,     0, 0                },
};
MAKE_NETMSG(Cli2Game_GameMgrMsg)


/* Server -> Client */
static dsNetMsgField Game2Cli_PingReply_Fields[] = {
    { kFieldInteger,    0, sizeof(dsUInt32) },  // Ping time
};
MAKE_NETMSG(Game2Cli_PingReply)

static dsNetMsgField Game2Cli_JoinAgeReply_Fields[] = {
    { kFieldInteger,    0, sizeof(dsUInt32) },  // Trans ID
    { kFieldInteger,    0, sizeof(dsUInt32) },  // Result
};
MAKE_NETMSG(Game2Cli_JoinAgeReply)

static dsNetMsgField Game2Cli_PropagateBuffer_Fields[] = {
    { kFieldInteger,    0, sizeof(dsUInt32) },  // Message Type
    { kFieldVarCount,   0, sizeof(dsUByte)  },  // Buffer Data
    { kFieldVarPtr,     0, 0                },
};
MAKE_NETMSG(Game2Cli_PropagateBuffer)

static dsNetMsgField Game2Cli_GameMgrMsg_Fields[] = {
    { kFieldVarCount,   0, sizeof(dsUByte)  },  // Message Data
    { kFieldVarPtr,     0, 0                },
};
MAKE_NETMSG(Game2Cli_GameMgrMsg)


const dsNetMsg* GET_Cli2Game(dsUInt32 msgId)
{
    static const dsNetMsg* s_messages[] = {
        &Cli2Game_PingRequest,
        &Cli2Game_JoinAgeRequest,
        &Cli2Game_PropagateBuffer,
        &Cli2Game_GameMgrMsg,
    };
    return (msgId < COUNTOF(s_messages, dsNetMsg*) ? s_messages[msgId] : NULL);
}

const dsNetMsg* GET_Game2Cli(dsUInt32 msgId)
{
    static const dsNetMsg* s_messages[] = {
        &Game2Cli_PingReply,
        &Game2Cli_JoinAgeReply,
        &Game2Cli_PropagateBuffer,
        &Game2Cli_GameMgrMsg,
    };
    return (msgId < COUNTOF(s_messages, dsNetMsg*) ? s_messages[msgId] : NULL);
}
