#include "../CommonSand.h"
#include "../dsUuid.h"
#include "dsVaultNode.h"

/* Client -> Server */
#define Cli2Vault_Header \
    dsUInt16 fMessage;

struct PACKED Cli2Vault_PingRequest {
    Cli2Vault_Header
    dsUInt32 fPingTimeMs;
};

struct Cli2Vault_VaultNodeCreate {
    Cli2Vault_Header
    dsUInt32 fTransId;
    dsUInt32 fNodeSize;
    dsUByte* fNodeData;
};

struct PACKED Cli2Vault_VaultNodeFetch {
    Cli2Vault_Header
    dsUInt32 fTransId;
    dsInt32 fNodeId;
};

struct Cli2Vault_VaultNodeSave {
    Cli2Vault_Header
    dsUInt32 fTransId;
    dsInt32 fNodeId;
    dsUuid fRevisionId;
    dsUInt32 fNodeSize;
    dsUByte* fNodeData;
};

struct PACKED Cli2Vault_VaultNodeAdd {
    Cli2Vault_Header
    dsUInt32 fTransId;
    dsInt32 fParentIdx, fChildIdx, fOwnerIdx;
};

struct PACKED Cli2Vault_VaultFetchNodeRefs {
    Cli2Vault_Header
    dsUInt32 fTransId;
    dsInt32 fNodeId;
};

struct Cli2Vault_VaultNodeFind {
    Cli2Vault_Header
    dsUInt32 fTransId;
    dsUInt32 fNodeSize;
    dsUByte* fNodeData;
};

/* Server -> Client */
#define Vault2Cli_Header \
    dsUInt16 fMessage;

struct PACKED Vault2Cli_PingReply {
    Vault2Cli_Header
    dsUInt32 fPingTimeMs;
};

struct PACKED Vault2Cli_VaultNodeCreated {
    Vault2Cli_Header
    dsUInt32 fTransId, fResult;
    dsInt32 fNodeId;
};

struct Vault2Cli_VaultNodeFetched {
    Vault2Cli_Header
    dsUInt32 fTransId, fResult;
    dsUInt32 fNodeSize;
    dsUByte* fNodeData;
};

struct PACKED Vault2Cli_VaultNodeChanged {
    Vault2Cli_Header
    dsInt32 fNodeId;
    dsUuid fRevisionId;
};

struct PACKED Vault2Cli_VaultNodeAdded {
    Vault2Cli_Header
    dsInt32 fParentIdx, fChildIdx, fOwnerIdx;
};

struct Vault2Cli_VaultNodeRefsFetched {
    Vault2Cli_Header
    dsUInt32 fTransId, fResult;
    dsUInt32 fNumRefs;
    dsVaultNodeRef* fRefs;
};

struct Vault2Cli_VaultNodeFindReply {
    Vault2Cli_Header
    dsUInt32 fTransId, fResult;
    dsUInt32 fNodeCount;
    dsInt32* fNodeIds;
};

struct PACKED Vault2Cli_VaultSaveNodeReply {
    Vault2Cli_Header
    dsUInt32 fTransId, fResult;
};

struct PACKED Vault2Cli_VaultAddNodeReply {
    Vault2Cli_Header
    dsUInt32 fTransId, fResult;
};
