/* dsVaultClient */
dsVaultClient::dsVaultClient(dsSocket* sock, dsVaultMsgHandler* callback)
             : fStatus(kNetPending), fSock(sock), fCallback(callback)
{
    if (sock == NULL)
        fStatus = kNetErrConnectFailed;
}

dsVaultClient::~dsVaultClient()
{ }

void dsVaultClient::finalize()
{
    fStatus = kNetErrDisconnected;
}

ENetError dsVaultClient::getStatus() const
{
    return fStatus;
}

void dsVaultClient::waitForStatus() const
{
    while (fStatus == kNetPending)
        dsThread::Yield();
}

dsUInt32 dsVaultClient::sendCreateRequest(const dsVaultNode& node)
{
    size_t bufSize = node.calcSize();
    dsUByte* buffer = new dsUByte[bufSize];
    node.write(buffer, bufSize);
    dsUInt32 result = sendCreateRequest(buffer, bufSize);
    delete[] buffer;
    return result;
}

dsUInt32 dsVaultClient::sendFindRequest(const dsVaultNode& node)
{
    size_t bufSize = node.calcSize();
    dsUByte* buffer = new dsUByte[bufSize];
    node.write(buffer, bufSize);
    dsUInt32 result = sendFindRequest(buffer, bufSize);
    delete[] buffer;
    return result;
}
